'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var colors = _interopDefault(require('colors/safe'));
var os = _interopDefault(require('os'));
var path = _interopDefault(require('path'));
var fs = _interopDefault(require('fs'));
var exec = _interopDefault(require('executive'));
var wsServer = _interopDefault(require('ws/lib/websocket-server'));
var vigil = _interopDefault(require('vigil'));
var url = require('url');
var url__default = _interopDefault(url);
var connect$1 = _interopDefault(require('connect'));
var marked = _interopDefault(require('marked'));
var basicAuth = _interopDefault(require('basic-auth-connect'));
var favicons = _interopDefault(require('connect-favicons'));
var http = _interopDefault(require('http'));
var logger = _interopDefault(require('morgan'));
var serveIndex = _interopDefault(require('serve-index'));
var serveStatic = _interopDefault(require('serve-static'));

// node_modules/es-tostring/index.mjs
function toString(obj) {
  return Object.prototype.toString.call(obj)
}

// node_modules/es-hasown/index.mjs

// node_modules/es-is/bool.js

// node_modules/es-is/infinite.js

// node_modules/es-is/number.js

// node_modules/es-is/array-like.js

// node_modules/es-is/array.js

// node_modules/es-is/function.js
// Generated by CoffeeScript 1.12.5
var isFunction;

var isFunction$1 = isFunction = function(value) {
  var str;
  if (typeof window !== 'undefined' && value === window.alert) {
    return true;
  }
  str = toString(value);
  return str === '[object Function]' || str === '[object GeneratorFunction]' || str === '[object AsyncFunction]';
};

// node_modules/es-is/object.js

// node_modules/es-is/arguments.js

// node_modules/es-is/async-function.js

// node_modules/es-is/string.js
// Generated by CoffeeScript 1.12.5
var isString;

var isString$1 = isString = function(value) {
  return toString(value) === '[object String]';
};

// node_modules/es-is/base64.js

// node_modules/es-is/date.js

// node_modules/es-is/utils.js

// node_modules/es-is/decimal.js

// node_modules/es-is/defined.js

// node_modules/es-is/divisible-by.js

// node_modules/es-is/element.js

// node_modules/es-is/empty-arguments.js

// node_modules/es-is/empty-array.js

// node_modules/es-is/empty.js

// node_modules/es-is/equal.js

// node_modules/es-is/error.js

// node_modules/es-is/even.js

// node_modules/es-is/false.js

// node_modules/es-is/generator-function.js

// node_modules/es-is/generator.js

// node_modules/es-is/ge.js

// node_modules/es-is/gt.js

// node_modules/es-is/hash.js

// node_modules/es-is/hex.js

// node_modules/es-is/hosted.js

// node_modules/es-is/instanceof.js

// node_modules/es-is/integer.js

// node_modules/es-is/le.js

// node_modules/es-is/lt.js

// node_modules/es-is/max.js

// node_modules/es-is/min.js

// node_modules/es-is/nan.js

// node_modules/es-is/null.js

// node_modules/es-is/odd.js

// node_modules/es-is/primitive.js

// node_modules/es-is/promise.js
// Generated by CoffeeScript 1.12.5
var isPromise;

var isPromise$1 = isPromise = function(value) {
  return !!value && (typeof value === 'object' || typeof value === 'function') && typeof value.then === 'function';
};

// node_modules/es-is/regexp.js

// node_modules/es-is/symbol.js

// node_modules/es-is/true.js

// node_modules/es-is/type.js

// node_modules/es-is/undefined.js

// node_modules/es-is/valid-date.js

// node_modules/es-is/within.js

// node_modules/es-is/index.mjs

// src/log.coffee
var _, log, method, prettyError, prettyJSON, theme;

theme = {
  debug: 'blue',
  info: 'white',
  warn: 'yellow',
  error: 'red',
  bebop: 'black',
  modified: 'cyan',
  compiled: 'blue'
};

colors.setTheme(theme);

prettyJSON = function(obj) {
  return JSON.stringify(obj, null, 2);
};

prettyError = function(err) {
  var msg, std;
  std = [];
  if (err.stdout != null) {
    std.push(err.stdout);
  }
  if (err.stderr != null) {
    std.push(err.stderr);
  }
  if (std.length > 0) {
    return std.join('\n');
  } else {
    msg = err.stack;
    return msg = msg.replace(/^Error: /, '');
  }
};

log = function() {
  if (root.console == null) {
    return console.log.apply(console, arguments);
  }
};

for (method in theme) {
  _ = theme[method];
  (function(method) {
    var prefix;
    prefix = colors[method](method + ' ');
    return log[method] = function(msg, extra) {
      var err;
      err = null;
      switch (typeof msg) {
        case 'string':
          msg = msg;
          break;
        case 'object':
          if (msg instanceof Error) {
            msg = prettyError(msg);
          } else {
            msg = '\n' + prettyJSON(msg);
          }
      }
      if (extra instanceof Error) {
        extra = prettyError(extra);
      } else {
        extra = prettyJSON(extra);
      }
      if (extra != null) {
        msg = msg + '\n' + extra;
      }
      msg = prefix + msg;
      if (err != null) {
        return console.error(msg);
      } else {
        return console.log(msg);
      }
    };
  })(method);
}

var log$1 = log;

// src/utils.coffee

// Locally require a module
var requireLocal = function(modulePath) {
  var localPath;
  localPath = path.join(process.cwd(), '/node_modules/', modulePath);
  try {
    return require(localPath);
  } catch (error) {
    try {
      return require(modulePath);
    } catch (error) {
      log$1.error(modulePath + ' not found, try npm install -g ' + modulePath);
      return process.exit(1);
    }
  }
};

// Return the first IPv4 address
var firstAddress = function() {
  var _, addr, i, iface, len, ref;
  ref = os.networkInterfaces();
  for (_ in ref) {
    iface = ref[_];
    for (i = 0, len = iface.length; i < len; i++) {
      addr = iface[i];
      // Skip IPv6 addresses
      if (addr.family !== 'IPv4') {
        continue;
      }
      // Skip private addresses
      if (addr.internal) {
        continue;
      }
      return addr.address;
    }
  }
};

// src/compilers/sass.coffee

function sass(src, dst, cb) {
  var sass;
  sass = requireLocal('node-sass');
  return sass.render({
    file: src,
    // importer: resolveNpm
    includePaths: [path.join(process.cwd(), 'node_modules')],
    outputStyle: 'nested'
  }, function(err, res) {
    if (err != null) {
      throw err;
    }
    return fs.writeFile(dst, res.css, function(err) {
      if (err != null) {
        throw err;
      }
      return cb(null, true);
    });
  });
}

// src/compilers/pug.coffee

function pug(src, dst, cb = function() {}) {
  var html, pug;
  pug = requireLocal('pug');
  html = pug.renderFile(src, {
    pretty: true
  });
  return fs.writeFile(dst, html, function(err) {
    if (err != null) {
      throw err;
    }
    return cb(null, true);
  });
}

// src/compilers/index.coffee
var compilers;

var index = compilers = {
  mappings: {
    coffee: 'js',
    hbs: 'html',
    jade: 'html',
    pug: 'html',
    sass: 'css',
    scss: 'css',
    styl: 'css'
  },
  compile: function(filename, opts = {}, cb = function() {}) {
    var c, cmd, cmds, compiler, dst, ext, src;
    if (typeof opts === 'function') {
      [opts, cb] = [{}, opts];
    }
    // get extension of file modified
    ext = (path.extname(filename)).substr(1);
    if ((compiler = this[ext]) == null) {
      return cb(null, false);
    }
    src = filename;
    dst = filename.replace(new RegExp(ext + '$'), this.mappings[ext]);
    // Rewrite destination so it's in buildDir
    if (opts.buildDir != null) {
      dst = dst.replace(opts.assetDir, opts.buildDir);
    }
    // compiler has callback, call function
    if (compiler.length === 3) {
      return compiler(src, dst, cb);
    }
    // compiler returns cmd for us to exec
    cmd = compiler(src, dst);
    if (isFunction$1(cmd)) {
      return cmd(cb);
    }
    if (isPromise$1(cmd)) {
      return cmd;
    }
    if (!isString$1(cmd)) {
      return cb(null, cmd != null ? cmd : false);
    }
    // use semicolon to delimite multiple commands
    cmds = (function() {
      var i, len, ref, results;
      ref = cmd.split(';');
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        c = ref[i];
        if ((c != null) && c.trim() !== '') {
          results.push(c.trim());
        }
      }
      return results;
    })();
    // execute compile step
    return exec.quiet(cmds, function(err, stdout, stderr) {
      if (err != null) {
        return cb(err);
      }
      if ((stderr != null) && stderr.trim() !== '') {
        return cb(new Error(stderr));
      }
      return cb(null, true);
    });
  },
  coffee: function(src, dst) {
    dst = path.dirname(dst);
    return `coffee -bmc -o ${dst} ${src}`;
  },
  hbs: function(src, dst) {
    var handlebars, template;
    handlebars = requireLocal('handlebars');
    template = handlebars.compile(fs.readFileSync(src, 'utf8'));
    return fs.writeFileSync(dst, template({}), 'utf8');
  },
  jade: function(src, dst) {
    dst = path.dirname(dst);
    return `jade --pretty ${src} --out ${dst}`;
  },
  pug: pug,
  styl: function(src, dst) {
    dst = path.dirname(dst);
    return `stylus ${src} -o ${dst}`;
  },
  sass: sass,
  scss: sass
};

// src/inject.coffee
// inject middleware into connect/express app
var injectConnectApp = function(app) {
  app.stack.splice(2, 0, {
    route: '',
    handle: _middleware
  });
  return app;
};

// inject middleware into http server
var injectHttpServer = function(server) {
  var app;
  // Get reference to current request listener
  app = server.listeners('request')[0];
  if (typeof app === 'function') {
    // Remove listener
    server.removeListener('request', app);
  }
  // Install our middleware, delegate to existing listener
  server.on('request', function(req, res) {
    return _middleware(req, res, function() {
      return app(req, res);
    });
  });
  return server;
};

// Automatically select the correct middleware to inject
var inject = function(app) {
  if (connect().toString() === app.toString()) {
    return injectConnectApp(app);
  } else {
    return injectHttpServer(app);
  }
};

// src/websocket.coffee
var WebSocketServer;

WebSocketServer = class WebSocketServer {
  constructor(server, opts = {}) {
    var ref, ref1;
    this.server = server;
    this.clients = {};
    this.id = 0;
    this.opts = {};
    // Options for ws.Server
    this.opts.path = (ref = opts.path) != null ? ref : '/_bebop';
    this.opts.perMessageDeflate = (ref1 = opts.perMessageDeflate) != null ? ref1 : false;
    this.opts.server = this.server;
    this.server.on('listening', () => {
      return this.attach();
    });
  }

  attach() {
    this.wss = new wsServer(this.opts);
    this.server.once('close', () => {
      return this.close();
    });
    return this.wss.on('connection', (ws) => {
      this.id += 1;
      ws.id = this.id;
      this.clients[ws.id] = ws;
      return ws.on('close', () => {
        return delete this.clients[ws.id];
      });
    });
  }

  // Close connections
  close() {
    var id;
    for (id in this.clients) {
      this.clients[id].close();
      delete this.clients[id];
    }
    return this.wss.close();
  }

  // Send message to connections
  send(message) {
    var err, id, results;
    results = [];
    for (id in this.clients) {
      try {
        results.push(this.clients[id].send(JSON.stringify(message)));
      } catch (error) {
        err = error;
        results.push(console.error(err.stack));
      }
    }
    return results;
  }

  modified(filename) {
    return this.send({
      type: 'modified',
      filename: filename
    });
  }

};

var WebSocketServer$1 = WebSocketServer;

// src/bebop.coffee
var Bebop;

Bebop = class Bebop {
  constructor(server1) {
    this.server = server1;
  }

  // Attach to a server and spin up websocket server, serve static files, etc.
  attach(server, opts = {}) {
    // Attach our middleware
    inject(server);
    // Attach websocket server
    return this.wss = new WebSocketServer$1({
      server: server
    });
  }

  close() {
    return this.wss.close.apply(this.wss, arguments);
  }

  send() {
    return this.wss.send.apply(this.wss, arguments);
  }

  listen() {
    return this.server.listen.apply(server, arguments);
  }

  // Attach and reload on file changes.
  reload(server, dir) {
    var wss;
    if (dir == null) {
      dir = process.cwd();
    }
    wss = this.attach(server);
    vigil.watch(dir, function(filename) {
      return this.wss.send({
        type: 'reload',
        filename: filename
      });
    });
    return wss;
  }

};

var Bebop$1 = Bebop;

// src/middleware/fake-express.coffee

// Connect is fairly minimal, flesh out req, res with a few helper
// methods/properties. Required for compatibility with non-standard connect
// middleware which expects various express conventions.
function fakeExpress(req, res, next) {
  var url$$1;
  // Slim stand-ins for what you get with Express
  res.redirect = function(loc) {
    res.writeHead(302, {
      Location: loc
    });
    return res.end();
  };
  res.set = function(headers) {
    var k, results, v;
    results = [];
    for (k in headers) {
      v = headers[k];
      results.push(res.setHeader(k, v));
    }
    return results;
  };
  res.send = function(body) {
    return res.end(body);
  };
  // Convenient for our middleware later
  url$$1 = url.parse(req.url);
  req.path = url$$1.pathname;
  req.search = url$$1.search;
  return next();
}

// src/middleware/live-reload.coffee
var LiveReload, livereload, serveStatic$1;

// Middleware to serve associated bebop client files
serveStatic$1 = function(req, res, next) {
  var contentType, file;
  switch (path.extname(req.url)) {
    case '.js':
      contentType = 'application/javascript';
      break;
    case '.coffee':
      contentType = 'application/coffeescript';
      break;
    case '.map':
      contentType = 'application/json';
      break;
    default:
      next();
  }
  // Get path to file
  if (/^\/src\/node_modules/.test(req.url)) {
    req.url = req.url.substring(4);
  }
  file = path.join(__dirname, '/..', req.url);
  // Serve static file
  res.writeHead(200, {
    'Content-Type': contentType
  });
  return fs.createReadStream(file).pipe(res);
};

// Live Reload middleware constructor
LiveReload = class LiveReload {
  constructor(opts = {}) {
    this.js = `<script src="/bebop.min.js"></script>\n<script>\n  var bebop = new Bebop(${JSON.stringify(opts)});\n  bebop.debug = true;\n  bebop.connect();\n</script>`;
  }

  // Monkey patch res.end to inject our script
  injectJs(res) {
    var appendScript, end, setHeader;
    appendScript = false;
    end = res.end;
    setHeader = res.setHeader;
    // Check content-type and increase content-length if we will append
    res.setHeader = (name, value) => {
      if (/text\/html/i.test(value)) {
        appendScript = true;
      } else if (name === 'Content-Length' && appendScript) {
        value = parseInt(value, 10) + this.js.length;
      }
      return setHeader.call(res, name, value);
    };
    // Append script if text/html content-type
    return res.end = (chunk, encoding) => {
      if (appendScript) {
        res.write(this.js, encoding);
      }
      return end.call(res, chunk, encoding);
    };
  }

  middleware(req, res, next) {
    // Serve static files
    if (/^\/bebop|src\/client\/bebop/.test(req.url)) {
      return serveStatic$1(req, res, next);
    }
    // Inject script into html pages
    this.injectJs(res);
    return next();
  }

};

// Generic connect compatible middleware to server client code.
var liveReload = livereload = function(opts = {}) {
  var r;
  r = new LiveReload(opts);
  // Wrap with a named function for easier debugging.
  return function liveReload(req, res, next) { return r.middleware(req, res, next); };};

// assets/github-markdown.css
var css = "";

// src/middleware/markdown.coffee

marked.setOptions({
  renderer: new marked.Renderer(),
  breaks: false,
  gfm: true,
  pedantic: false,
  sanitize: true,
  smartLists: true,
  smartypants: false,
  tables: true
});

function markdown(opts = {}) {
  var maxAge;
  maxAge = opts.maxAge || 0;
  return function(req, res, next) {
    var path$$1, pathname;
    ({pathname} = url__default.parse(req.url, true, true));
    // Only process markdown files
    if (!/\.md$/.test(pathname)) {
      return next();
    }
    path$$1 = pathname.replace(/^\//, '');
    return fs.exists(path$$1, function(exists) {
      var now;
      if (!exists) {
        return next();
      }
      now = new Date().toUTCString();
      res.setHeader('Content-Type', 'text/html; charset=UTF-8');
      if (!res.getHeader('Cache-Control')) {
        res.setHeader('Cache-Control', 'public, max-age=' + (maxAge / 1000));
      }
      if (!res.getHeader('Date')) {
        res.setHeader('Date', now);
      }
      if (!res.getHeader('Last-Modified')) {
        res.setHeader('Last-Modified', now);
      }
      if (req.method === 'HEAD') {
        res.writeHead(200);
        return res.end();
      }
      if (req.method !== 'GET') {
        return next();
      }
      return fs.readFile(path$$1, 'utf-8', function(err, data) {
        if (err != null) {
          throw err;
        }
        res.writeHead(200);
        return res.end(`<html>\n  <head>\n    <title>${path$$1}</title>\n    <style>\n    ${css}\n    </style>\n  </head>\n  <body>\n  ${marked(data)}\n  </body>\n</html>`);
      });
    });
  };
}

// src/middleware/node-modules-redirect.coffee
// Automatically redirect to root /node_modules handler
var nodeModulesRedirect;

var nodeModulesRedirect$1 = nodeModulesRedirect = function(req, res, next) {
  var nm;
  nm = req.path.indexOf('node_modules');
  if (~nm) {
    res.writeHead(301, {
      Location: `/${req.path.substr(nm)}`
    });
    return res.end();
  } else {
    return next();
  }
};

// src/middleware/render-404.coffee
var defaultPaths, render404;

defaultPaths = function(opts) {
  var basePaths, ext, exts, i, j, len, len1, p, pathSet;
  exts = ['.html', '.htm', '.txt', '.md'];
  basePaths = [opts.assetDir, opts.buildDir, opts.workDir];
  pathSet = {};
  for (i = 0, len = basePaths.length; i < len; i++) {
    p = basePaths[i];
    for (j = 0, len1 = exts.length; j < len1; j++) {
      ext = exts[j];
      pathSet[path.join(p, '404' + ext)] = true;
    }
  }
  // Return just unique paths
  return Object.keys(pathSet);
};

var render404$1 = render404 = function(opts = {}) {
  var i, len, p, page404, ref, ref1;
  page404 = (ref = opts.page404) != null ? ref : '';
  if (page404 === '') {
    ref1 = defaultPaths(opts);
    for (i = 0, len = ref1.length; i < len; i++) {
      p = ref1[i];
      (function(p) {
        return fs.access(p, function(err) {
          if (err == null) {
            page404 = p;
            return console.log('detected 404 page:', page404);
          }
        });
      })(p);
    }
  }
  return function(req, res, next) {
    var now;
    if (!page404) {
      return next();
    }
    now = new Date().toUTCString();
    res.setHeader('Content-Type', 'text/html; charset=UTF-8');
    res.setHeader('Cache-Control', 'public, max-age=' + 0);
    if (!res.getHeader('Date')) {
      res.setHeader('Date', now);
    }
    if (!res.getHeader('Last-Modified')) {
      res.setHeader('Last-Modified', now);
    }
    if (req.method === 'HEAD') {
      res.writeHead(200);
      return res.end();
    }
    if (req.method !== 'GET') {
      return next();
    }
    return fs.readFile(page404, 'utf-8', function(err, data) {
      if (err != null) {
        throw err;
      }
      res.writeHead(404);
      return res.end(data);
    });
  };
};

// src/middleware/strip-html.coffee
var stripHtml, trailingHtmlRe;

trailingHtmlRe = /\.html$/; // Path ends with .html


// Strip .html from paths for nicer user experience
var stripHtml$1 = stripHtml = function(req, res, next) {
  var loc;
  if (!trailingHtmlRe.test(req.url)) {
    return next();
  }
  loc = req.url.replace(/index.html$/, '');
  loc = loc.replace(trailingHtmlRe, '');
  return res.redirect(loc);
};

// src/middleware/strip-slash.coffee
var stripSlash, trailingSlashRe;

trailingSlashRe = /\.html\/$/; // Slash erroneously appended to path name


// Detect odd bug with some browsers and redirect
var stripSlash$1 = stripSlash = function(req, res, next) {
  var loc;
  if (!trailingSlashRe.test(req.url)) {
    return next();
  }
  loc = req.url.replace(trailingSlashRe, '.html');
  return res.redirect(loc);
};

// src/middleware/index.coffee

var index$1 = /*#__PURE__*/Object.freeze({
  fakeExpress: fakeExpress,
  liveReload: liveReload,
  markdown: markdown,
  nodeModulesRedirect: nodeModulesRedirect$1,
  render404: render404$1,
  stripHtml: stripHtml$1,
  stripSlash: stripSlash$1
});

// src/server.coffee
var Server, cacheControl;

cacheControl = function(res, path$$1) {
  if ((serveStatic.mime.lookup(path$$1)) === 'text/html') {
    res.setHeader('Cache-Control', 'no-cache, no-store, must-revalidate');
    return res.setHeader('Pragma', 'no-cache');
  }
};

Server = class Server extends http.Server {
  constructor(opts = {}) {
    var app, dir, i, len, ref, ref1, ref2, ref3, serveOpts;
    if (opts.host == null) {
      opts.host = '0.0.0.0';
    }
    if (opts.port == null) {
      opts.port = 1987;
    }
    if (opts.buildDir == null) {
      opts.buildDir = process.cwd();
    }
    if (opts.workDir == null) {
      opts.workDir = process.cwd();
    }
    if (opts.hideIcon == null) {
      opts.hideIcon = false;
    }
    app = connect$1();
    // Use some helper middleware
    app.use(fakeExpress);
    app.use(stripHtml$1);
    app.use(stripSlash$1);
    // Fallback to our favicons
    if (opts.hideIcon == null) {
      app.use(favicons(__dirname + '/../assets'));
    }
    // Log requests
    app.use(logger('dev'));
    // Support Basic Auth
    if (opts.user && opts.pass) {
      app.use(basicAuth(opts.user, opts.pass));
    }
    // Install Bebop livereload middleware
    app.use(liveReload());
    // Markdown helper
    app.use(markdown());
    serveOpts = {
      // Never want to cache for local development purposes
      cacheControl: false,
      setHeaders: cacheControl,
      // Fallthrough and serve directory listings
      fallthrough: true,
      // Allow a few options to be customized
      dotfiles: (ref = opts.dotfiles) != null ? ref : 'deny',
      extensions: (ref1 = opts.extensions) != null ? ref1 : ['html', 'htm'],
      index: (ref2 = opts.index) != null ? ref2 : ['index.html', 'index.htm']
    };
    // Serve files and indexes from build directory
    app.use(serveStatic(opts.buildDir, serveOpts));
    app.use(serveIndex(opts.buildDir, {
      hidden: true
    }));
    // Automatically server files from node_modules for easier debugging
    app.use('/node_modules', serveStatic(process.cwd() + '/node_modules', serveOpts));
    app.use(nodeModulesRedirect$1);
    ref3 = [opts.assetDir, opts.workDir];
    // Also serve content from assets and current working directories. This is
    // useful for serving files referenced by sourcemaps.
    for (i = 0, len = ref3.length; i < len; i++) {
      dir = ref3[i];
      if ((dir != null) && dir !== '' && dir !== opts.buildDir) {
        app.use(serveStatic(dir, serveOpts));
      }
    }
    // Redirect 404 pages
    app.use(render404$1(opts));
    // Pass connect app to http.Server
    super(app);
    // Helpful to save reference
    this.app = app;
    this.opts = opts;
  }

  run(cb = function() {}) {
    var host, port, workDir;
    ({workDir, host, port} = this.opts);
    this.once('listening', function() {
      var dir;
      dir = path.basename(workDir);
      if (host === '0.0.0.0') {
        host = firstAddress();
        log$1.bebop(`serving ${dir} at`);
        if (host != null) {
          console.log(`    http://${host}:${port}`);
        }
        return console.log(`    http://localhost:${port}`);
      } else {
        return log$1.bebop(`serving ${dir} at http://${host}:${port}`);
      }
    });
    process.once('uncaughtException', (err) => {
      if (err.code === 'EADDRINUSE') {
        log$1.error('address in use, retrying...');
        this.close();
        this.opts.port++;
        return setTimeout((() => {
          return this.run();
        }), 1000);
      } else {
        return log$1.error(err);
      }
    });
    return this.listen(port, host, cb);
  }

};

var Server$1 = Server;

// src/index.coffee

var index$2 = new Bebop$1;

exports.Bebop = Bebop$1;
exports.Server = Server$1;
exports.WebSocketServer = WebSocketServer$1;
exports.compilers = index;
exports.middleware = index$1;
exports.default = index$2;
//# sourceMappingURL=bebop.js.map
